diff --git a/ldap/servers/slapd/back-ldbm/ldbm_search.c b/ldap/servers/slapd/back-ldbm/ldbm_search.c
index 3b3b5b2..5ce4cf3 100644
--- a/ldap/servers/slapd/back-ldbm/ldbm_search.c
+++ b/ldap/servers/slapd/back-ldbm/ldbm_search.c
@@ -603,7 +603,7 @@ ldbm_back_search( Slapi_PBlock *pb )
     }
     else
     {
-        time_t time_up= 0;
+        struct timespec expire_time = {0};
         int lookthrough_limit = 0;
         struct vlv_response vlv_response_control;
         int abandoned= 0;
@@ -670,16 +670,10 @@ ldbm_back_search( Slapi_PBlock *pb )
              */
             if (sort && (NULL != candidates))
             {
-                time_t optime = 0;
                 int tlimit = 0;
 
                 slapi_pblock_get( pb, SLAPI_SEARCH_TIMELIMIT, &tlimit );
-                slapi_pblock_get( pb, SLAPI_OPINITIATED_TIME, &optime );
-                /* 
-                 * (tlimit==-1) means no time limit
-                 */
-                time_up = (tlimit==-1 ? -1 : optime + tlimit);
-
+                slapi_operation_time_expiry(operation, (time_t)tlimit, &expire_time);
                 lookthrough_limit = compute_lookthrough_limit( pb, li );
             }
 
@@ -695,7 +689,7 @@ ldbm_back_search( Slapi_PBlock *pb )
                 if (filter) {
                     rc = vlv_filter_candidates(be, pb, candidates, basesdn,
                                                scope, filter, &idl,
-                                               lookthrough_limit, time_up);
+                                               lookthrough_limit, &expire_time);
                 }
                 switch (rc) {
                 case LDAP_SUCCESS:  /* Everything OK */
@@ -761,7 +755,7 @@ ldbm_back_search( Slapi_PBlock *pb )
                     sort_log_access(pb,sort_control,candidates);
                 }
                 sort_return_value = sort_candidates( be, lookthrough_limit,
-                                                     time_up, pb, candidates,
+                                                     &expire_time, pb, candidates,
                                                      sort_control,
                                                      &sort_error_type );
                 /* Fix for bugid # 394184, SD, 20 Jul 00 */
@@ -1426,7 +1420,7 @@ ldbm_back_next_search_entry_ext( Slapi_PBlock *pb, int use_extension )
     ID                     id;
     struct backentry       *e;
     int                    nentries;
-    time_t                 curtime, stoptime, optime;
+    struct timespec        expire_time;
     int                    tlimit, llimit, slimit, isroot;
     struct berval          **urls = NULL;
     int                    err;
@@ -1458,7 +1452,6 @@ ldbm_back_next_search_entry_ext( Slapi_PBlock *pb, int use_extension )
     slapi_pblock_get( pb, SLAPI_NENTRIES, &nentries );
     slapi_pblock_get( pb, SLAPI_SEARCH_SIZELIMIT, &slimit );
     slapi_pblock_get( pb, SLAPI_SEARCH_TIMELIMIT, &tlimit );
-    slapi_pblock_get( pb, SLAPI_OPINITIATED_TIME, &optime );
     slapi_pblock_get( pb, SLAPI_REQUESTOR_ISROOT, &isroot );
     slapi_pblock_get( pb, SLAPI_SEARCH_REFERRALS, &urls );
     slapi_pblock_get( pb, SLAPI_TARGET_UNIQUEID, &target_uniqueid );
@@ -1528,7 +1521,7 @@ ldbm_back_next_search_entry_ext( Slapi_PBlock *pb, int use_extension )
         sr->sr_vlventry = NULL;
     }
 
-    stoptime = optime + tlimit;
+    slapi_operation_time_expiry(op, (time_t)tlimit, &expire_time);
     llimit = sr->sr_lookthroughlimit;
 
     /* Find the next candidate entry and return it. */
@@ -1548,10 +1541,12 @@ ldbm_back_next_search_entry_ext( Slapi_PBlock *pb, int use_extension )
             goto bail;
         }
 
+        /*
+         * Check this only every few iters to prevent smashing the clock api?
+         */
         /* check time limit */
-        curtime = current_time();
-        if ( tlimit != -1 && curtime > stoptime )
-        {
+        if (slapi_timespec_expire_check(&expire_time) == TIMER_EXPIRED) {
+            slapi_log_err(SLAPI_LOG_TRACE, "ldbm_back_next_search_entry_ext", "LDAP_TIMELIMIT_EXCEEDED\n");
             slapi_pblock_set( pb, SLAPI_SEARCH_RESULT_SET_SIZE_ESTIMATE, &estimate );
             if ( use_extension ) {
                 slapi_pblock_set( pb, SLAPI_SEARCH_RESULT_ENTRY_EXT, NULL );
@@ -1562,7 +1557,6 @@ ldbm_back_next_search_entry_ext( Slapi_PBlock *pb, int use_extension )
             slapi_send_ldap_result( pb, LDAP_TIMELIMIT_EXCEEDED, NULL, NULL, nentries, urls );
             goto bail;
         }
-            
         /* check lookthrough limit */
         if ( llimit != -1 && sr->sr_lookthroughcount >= llimit )
         {
@@ -1576,7 +1570,7 @@ ldbm_back_next_search_entry_ext( Slapi_PBlock *pb, int use_extension )
             slapi_send_ldap_result( pb, LDAP_ADMINLIMIT_EXCEEDED, NULL, NULL, nentries, urls );
             goto bail;
         }
-            
+
         /*
          * Get the entry ID
          */
diff --git a/ldap/servers/slapd/back-ldbm/ldif2ldbm.c b/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
index 6d897ed..641fcde 100644
--- a/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
+++ b/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
@@ -2865,7 +2865,7 @@ int ldbm_back_upgradedb(Slapi_PBlock *pb)
     {
         if (PR_FILE_DIRECTORY == info.type)    /* directory exists */
         {
-            time_t tm = time(0);    /* long */
+            time_t tm = slapi_current_utc_time();
 
             char *tmpname = slapi_ch_smprintf("%s/%ld", dest_dir, tm);
             dest_dir = tmpname;
diff --git a/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h b/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
index ca2ff7b..1fc8c08 100644
--- a/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
+++ b/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
@@ -278,7 +278,7 @@ int idl_new_compare_dups(
 );
 IDList *idl_new_range_fetch(backend *be, DB* db, DBT *lowerkey, DBT *upperkey,
                             DB_TXN *txn, struct attrinfo *a, int *flag_err,
-                            int allidslimit, int sizelimit, time_t stoptime,
+                            int allidslimit, int sizelimit, struct timespec *expire_time,
                             int lookthrough_limit, int operator);
 
 /*
@@ -451,7 +451,7 @@ typedef struct sort_spec_thing sort_spec_thing;
 typedef struct sort_spec_thing sort_spec;
 
 void sort_spec_free(sort_spec *s);
-int sort_candidates(backend *be, int lookthrough_limit, time_t time_up, Slapi_PBlock *pb, IDList *candidates, sort_spec_thing *sort_spec, char **sort_error_type) ;
+int sort_candidates(backend *be, int lookthrough_limit, struct timespec *expire_time, Slapi_PBlock *pb, IDList *candidates, sort_spec_thing *sort_spec, char **sort_error_type) ;
 int make_sort_response_control ( Slapi_PBlock *pb, int code, char *error_type);
 int parse_sort_spec(struct berval *sort_spec_ber, sort_spec **ps);
 struct berval* attr_value_lowest(struct berval **values, value_compare_fn_type compare_fn);
@@ -541,7 +541,7 @@ int vlv_search_build_candidate_list(Slapi_PBlock *pb, const Slapi_DN *base, int
                     const struct vlv_request *vlv_request_control, IDList** candidates, struct vlv_response *vlv_response_control);
 int vlv_update_index(struct vlvIndex* p, back_txn *txn, struct ldbminfo *li, Slapi_PBlock *pb, struct backentry* oldEntry, struct backentry* newEntry);
 int vlv_update_all_indexes(back_txn *txn, backend *be, Slapi_PBlock *pb, struct backentry* oldEntry, struct backentry* newEntry);
-int vlv_filter_candidates(backend *be, Slapi_PBlock *pb, const IDList *candidates, const Slapi_DN *base, int scope, Slapi_Filter *filter, IDList** filteredCandidates,int lookthrough_limit, time_t time_up);
+int vlv_filter_candidates(backend *be, Slapi_PBlock *pb, const IDList *candidates, const Slapi_DN *base, int scope, Slapi_Filter *filter, IDList** filteredCandidates,int lookthrough_limit, struct timespec *expire_time);
 int vlv_trim_candidates_txn(backend *be, const IDList *candidates, const sort_spec* sort_control, const struct vlv_request *vlv_request_control, IDList** filteredCandidates,struct vlv_response *pResponse, back_txn *txn);
 int vlv_trim_candidates(backend *be, const IDList *candidates, const sort_spec* sort_control, const struct vlv_request *vlv_request_control, IDList** filteredCandidates,struct vlv_response *pResponse);
 int vlv_parse_request_control(backend *be, struct berval *vlv_spec_ber, struct vlv_request* vlvp);
diff --git a/ldap/servers/slapd/back-ldbm/sort.c b/ldap/servers/slapd/back-ldbm/sort.c
index 0650472..3b7221a 100644
--- a/ldap/servers/slapd/back-ldbm/sort.c
+++ b/ldap/servers/slapd/back-ldbm/sort.c
@@ -21,7 +21,7 @@
 struct baggage_carrier {
 	backend *be; /* For id2entry */
 	Slapi_PBlock *pb; /* For slapi_op_abandoned */
-	time_t	stoptime; /* For timelimit policing */
+	struct timespec *expire_time;
 	int lookthrough_limit;
 	int check_counter; /* Used to avoid checking every 100ns */
 };
@@ -137,7 +137,7 @@ void sort_log_access(Slapi_PBlock *pb,sort_spec_thing *s,IDList *candidates)
  * Plan C:  We determine that sorting these suckers is
  *			far too hard for us to even try, so we refuse.
  */
-int sort_candidates(backend *be,int lookthrough_limit,time_t time_up, Slapi_PBlock *pb, 
+int sort_candidates(backend *be,int lookthrough_limit, struct timespec *expire_time, Slapi_PBlock *pb,
 					IDList	*candidates, sort_spec_thing *s, char **sort_error_type)
 {
 	int return_value = LDAP_SUCCESS;
@@ -185,7 +185,7 @@ int sort_candidates(backend *be,int lookthrough_limit,time_t time_up, Slapi_PBlo
 
 	bc.be = be; 
 	bc.pb = pb; 
-	bc.stoptime = time_up;
+	bc.expire_time = expire_time;
 	bc.lookthrough_limit = lookthrough_limit;
 	bc.check_counter = 1;
 
@@ -580,7 +580,6 @@ static int compare_entries_sv(ID *id_a, ID *id_b, sort_spec *s,baggage_carrier *
  */
 static int sort_check(baggage_carrier *bc)
 {
-	time_t curtime = 0;
 	/* check for abandon */
 	if ( slapi_op_abandoned( bc->pb)) {
 	    return LDAP_OTHER;
@@ -590,9 +589,8 @@ static int sort_check(baggage_carrier *bc)
 
 	if (0 == ((bc->check_counter)++ % CHECK_INTERVAL) ) {
 
-		/* check time limit */
-		curtime = current_time();
-		if ( bc->stoptime != -1 && curtime > bc->stoptime ) {
+		if (slapi_timespec_expire_check(bc->expire_time) == TIMER_EXPIRED) {
+			slapi_log_err(SLAPI_LOG_TRACE, "sort_check", "LDAP_TIMELIMIT_EXCEEDED\n");
 			return LDAP_TIMELIMIT_EXCEEDED;
 		}
 			
diff --git a/ldap/servers/slapd/back-ldbm/vlv.c b/ldap/servers/slapd/back-ldbm/vlv.c
index 37cf25d..a299341 100644
--- a/ldap/servers/slapd/back-ldbm/vlv.c
+++ b/ldap/servers/slapd/back-ldbm/vlv.c
@@ -1355,7 +1355,7 @@ vlv_build_candidate_list( backend *be, struct vlvIndex* p, const struct vlv_requ
  *       other (80)
  */
 int
-vlv_filter_candidates(backend *be, Slapi_PBlock *pb, const IDList *candidates, const Slapi_DN *base, int scope, Slapi_Filter *filter, IDList** filteredCandidates, int lookthrough_limit, time_t time_up)
+vlv_filter_candidates(backend *be, Slapi_PBlock *pb, const IDList *candidates, const Slapi_DN *base, int scope, Slapi_Filter *filter, IDList** filteredCandidates, int lookthrough_limit, struct timespec *expire_time)
 {
     IDList* resultIdl= NULL;
 	int return_value = LDAP_SUCCESS;
@@ -1424,12 +1424,20 @@ vlv_filter_candidates(backend *be, Slapi_PBlock *pb, const IDList *candidates, c
         	if ( counter++ % 10 == 0 )
         	{
         		/* check time limit */
+#ifdef HAVE_CLOCK_GETTIME
+                if (slapi_timespec_expire_check(expire_time) == TIMER_EXPIRED) {
+                    slapi_log_err(SLAPI_LOG_TRACE, "vlv_filter_candidates", "LDAP_TIMELIMIT_EXCEEDED\n");
+                    return_value= LDAP_TIMELIMIT_EXCEEDED;
+                    done= 1;
+                }
+#else
         		time_t curtime = current_time();
         		if ( time_up != -1 && curtime > time_up )
         		{
                     return_value= LDAP_TIMELIMIT_EXCEEDED;
                     done= 1;
         		}
+#endif
         		/* check lookthrough limit */
         		if ( lookthrough_limit != -1 && lookedat>lookthrough_limit )
         		{
diff --git a/ldap/servers/slapd/back-ldbm/vlv_srch.c b/ldap/servers/slapd/back-ldbm/vlv_srch.c
index 5bdf4f7..3f3b00a 100644
--- a/ldap/servers/slapd/back-ldbm/vlv_srch.c
+++ b/ldap/servers/slapd/back-ldbm/vlv_srch.c
@@ -289,10 +289,10 @@ struct vlvIndex*
 vlvSearch_findenabled(backend *be,struct vlvSearch* plist, const Slapi_DN *base, int scope, const char *filter, const sort_spec* sort_control)
 {
     struct vlvSearch *t= plist;
-	struct vlvIndex *pi= NULL;
+    struct vlvIndex *pi= NULL;
     for(; (t!=NULL) && (pi == NULL); t= t->vlv_next)
     {
-		pi= vlvSearch_equal(t,base,scope,filter,sort_control);
+        pi= vlvSearch_equal(t,base,scope,filter,sort_control);
         if(pi!=NULL)
         {
             if(!vlvIndex_enabled(pi))
@@ -302,11 +302,9 @@ vlvSearch_findenabled(backend *be,struct vlvSearch* plist, const Slapi_DN *base,
                  * But it hasn't been enabled yet.  Check to see if the
                  * index is there.  But, only check once every 60 seconds.
                  */
-            	time_t curtime = current_time();
-                if(curtime>pi->vlv_lastchecked+60)
-                {
+                if (slapi_timespec_expire_check(&(pi->vlv_nextcheck)) == TIMER_EXPIRED) {
                     vlvIndex_checkforindex(pi, be);
-                    pi->vlv_lastchecked= current_time();
+                    slapi_timespec_expire_at(60, &(pi->vlv_nextcheck));
                 }
             }
             if(!vlvIndex_enabled(pi))
@@ -505,20 +503,9 @@ vlvIndex_new()
     struct vlvIndex* p = (struct vlvIndex*)slapi_ch_calloc(1,sizeof(struct vlvIndex));
     if(p!=NULL)
     {
-        p->vlv_sortspec= NULL;
         p->vlv_attrinfo= attrinfo_new();
-        p->vlv_sortkey= NULL;
-        p->vlv_filename= NULL;
-	    p->vlv_mrpb= NULL;
         p->vlv_indexlength_lock= PR_NewLock();
-        p->vlv_indexlength_cached= 0;
-        p->vlv_indexlength= 0;
         p->vlv_online = 1;
-        p->vlv_enabled = 0;
-        p->vlv_lastchecked= 0;
-        p->vlv_uses= 0;
-        p->vlv_search= NULL;
-        p->vlv_next= NULL;
     }
     return p;
 }
@@ -611,7 +598,7 @@ vlvIndex_init(struct vlvIndex* p, backend *be, struct vlvSearch* pSearch, const
         {
             vlvIndex_checkforindex(p, be);
         }
-        p->vlv_lastchecked= current_time();
+        slapi_timespec_expire_at(60, &(p->vlv_nextcheck));
     }
     slapi_ch_free((void**)&filename);
 }
diff --git a/ldap/servers/slapd/back-ldbm/vlv_srch.h b/ldap/servers/slapd/back-ldbm/vlv_srch.h
index 6322f80..67cc495 100644
--- a/ldap/servers/slapd/back-ldbm/vlv_srch.h
+++ b/ldap/servers/slapd/back-ldbm/vlv_srch.h
@@ -89,7 +89,7 @@ struct vlvIndex
     int vlv_online;             /* turned off when generating index */
 
     /* The last time we checked to see if the index file was available */
-    time_t vlv_lastchecked;
+    struct timespec vlv_nextcheck;
 
     /* The number of uses this search has received since start up */
     uint64_t vlv_uses;
diff --git a/ldap/servers/slapd/connection.c b/ldap/servers/slapd/connection.c
index d3b0f7e..55789a9 100644
--- a/ldap/servers/slapd/connection.c
+++ b/ldap/servers/slapd/connection.c
@@ -414,7 +414,7 @@ connection_reset(Connection* conn, int ns, PRNetAddr * from, int fromLen __attri
 
     /* initialize the remaining connection fields */
     conn->c_ldapversion = LDAP_VERSION3;
-    conn->c_starttime = current_time();
+    conn->c_starttime = slapi_current_utc_time();
     conn->c_idlesince = conn->c_starttime;
     conn->c_flags = is_SSL ? CONN_FLAG_SSL : 0;
     conn->c_authtype = slapi_ch_strdup(SLAPD_AUTH_NONE);
@@ -1384,7 +1384,7 @@ void connection_check_activity_level(Connection *conn)
 	/* store current count in the previous count slot */
 	conn->c_private->previous_op_count = current_count;
 	/* update the last checked time */
-	conn->c_private->previous_count_check_time = current_time();
+	conn->c_private->previous_count_check_time = slapi_current_utc_time();
 	PR_ExitMonitor(conn->c_mutex);
 	slapi_log_err(SLAPI_LOG_CONNS,"connection_check_activity_level", "conn %" PRIu64 " activity level = %d\n",conn->c_connid,delta_count); 
 }
@@ -1621,7 +1621,7 @@ connection_threadmain()
 					conn->c_opsinitiated, conn->c_refcnt, conn->c_flags);
 		}
 
-		curtime = current_time();
+		curtime = slapi_current_utc_time();
 #define DB_PERF_TURBO 1		
 #if defined(DB_PERF_TURBO)
 		/* If it's been a while since we last did it ... */
diff --git a/ldap/servers/slapd/conntable.c b/ldap/servers/slapd/conntable.c
index 1c6757d..3eda3d0 100644
--- a/ldap/servers/slapd/conntable.c
+++ b/ldap/servers/slapd/conntable.c
@@ -364,7 +364,7 @@ connection_table_as_entry(Connection_Table *ct, Slapi_Entry *e)
 		PR_EnterMonitor(ct->c[i].c_mutex);
 		if ( ct->c[i].c_sd != SLAPD_INVALID_SOCKET )
 		{
-			char buf2[20];
+			char buf2[SLAPI_TIMESTAMP_BUFSIZE];
 			int lendn = ct->c[i].c_dn ? strlen(ct->c[i].c_dn) : 6; /* "NULLDN" */
 			char *bufptr = &buf[0];
 			char *newbuf = NULL;
@@ -381,7 +381,7 @@ connection_table_as_entry(Connection_Table *ct, Slapi_Entry *e)
 			}
 
 			gmtime_r( &ct->c[i].c_starttime, &utm );
-			strftime( buf2, sizeof(buf2), "%Y%m%d%H%M%SZ", &utm );
+			strftime( buf2, SLAPI_TIMESTAMP_BUFSIZE, "%Y%m%d%H%M%SZ", &utm );
 
 			/*
 			 * Max threads per connection stats
diff --git a/ldap/servers/slapd/csngen.c b/ldap/servers/slapd/csngen.c
index 468979a..3313019 100644
--- a/ldap/servers/slapd/csngen.c
+++ b/ldap/servers/slapd/csngen.c
@@ -69,14 +69,6 @@ struct csngen
 
 /*
  * **************************************************************************
- * global data
- * **************************************************************************
- */
-
-static time_t g_sampled_time;	/* time obtained from time() call */
-
-/*
- * **************************************************************************
  * forward declarations	of helper functions
  * **************************************************************************
  */
@@ -143,7 +135,7 @@ csngen_new (ReplicaId rid, Slapi_Attr *state)
 	else
 	{
 		/* new generator */
-		gen->state.sampled_time = current_time ();
+		gen->state.sampled_time = slapi_current_utc_time();
 		gen->state.local_offset = 0;
 		gen->state.remote_offset = 0;
 		gen->state.seq_num = 0;
@@ -199,13 +191,10 @@ csngen_new_csn (CSNGen *gen, CSN **csn, PRBool notify)
 
     slapi_rwlock_wrlock (gen->lock);
 
-    if (g_sampled_time == 0)
-        csngen_update_time ();
-
-    cur_time = g_sampled_time;
+    cur_time = slapi_current_utc_time();
 
     /* check if the time should be adjusted */
-	delta = cur_time - gen->state.sampled_time;
+    delta = cur_time - gen->state.sampled_time;
     if (delta > 0)
     {
         rc = _csngen_adjust_local_time (gen, cur_time);
@@ -311,8 +300,7 @@ int csngen_adjust_time(CSNGen *gen, const CSN* csn)
                          gen->state.remote_offset);
     }
     /* make sure we have the current time */
-    csngen_update_time();
-    cur_time = g_sampled_time;
+    cur_time = slapi_current_utc_time();
 
     /* make sure sampled_time is current */
     /* must only call adjust_local_time if the current time is greater than
@@ -460,13 +448,6 @@ void csngen_unregister_callbacks(CSNGen *gen, void *cookie)
     }
 }
 
-/* this functions is periodically called from daemon.c to
-   update time used by all generators */
-void csngen_update_time ()
-{
-    g_sampled_time = current_time ();
-}
-
 /* debugging function */
 void csngen_dump_state (const CSNGen *gen)
 {
@@ -881,7 +862,9 @@ _csngen_local_tester_main (void *data)
 		/* sleep for 30 seconds */
 		DS_Sleep (PR_SecondsToInterval(60));
 
-		g_sampled_time -= slapi_rand () % 100;		
+		/*
+		 * g_sampled_time -= slapi_rand () % 100;		
+		 */
 
 		csngen_dump_state (gen);
 	}
diff --git a/ldap/servers/slapd/daemon.c b/ldap/servers/slapd/daemon.c
index 1592f9d..fc8d7df 100644
--- a/ldap/servers/slapd/daemon.c
+++ b/ldap/servers/slapd/daemon.c
@@ -150,7 +150,6 @@ accept_and_configure(int s __attribute__((unused)), PRFileDesc *pr_acceptfd, PRN
 /* 
  * This is the shiny new re-born daemon function, without all the hair
  */
-/* GGOODREPL static void handle_timeout( void ); */
 static int handle_new_connection(Connection_Table *ct, int tcps, PRFileDesc *pr_acceptfd, int secure, int local, Connection **newconn );
 static void ns_handle_new_connection(struct ns_job_t *job);
 static void handle_pr_read_ready(Connection_Table *ct, PRIntn num_poll);
@@ -259,23 +258,6 @@ int daemon_pre_setuid_init(daemon_ports_t *ports)
  */
 static int time_shutdown = 0;
 
-void * 
-time_thread(void *nothing __attribute__((unused)))
-{
-    PRIntervalTime    interval;
-
-    interval = PR_SecondsToInterval(1);
-
-    while(!time_shutdown) {
-        poll_current_time();
-        csngen_update_time ();
-        DS_Sleep(interval);
-    }
-
-    /*NOTREACHED*/
-    return(NULL);
-}
-
 /*
  *  Return a copy of the mount point for the specified directory
  */
@@ -666,7 +648,7 @@ disk_monitoring_thread(void *nothing __attribute__((unused)))
             slapi_log_err(SLAPI_LOG_ALERT, "disk_monitoring_thread", "Disk space on (%s) is too far below the threshold(%" PRIu64 " bytes).  "
                 "Waiting %d minutes for disk space to be cleaned up before shutting slapd down...\n",
                 dirstr, threshold, (grace_period / 60));
-            time(&start);
+            start = slapi_current_utc_time();
             now = start;
             while( (now - start) < grace_period ){
                 if(g_get_shutdown()){
@@ -715,7 +697,7 @@ disk_monitoring_thread(void *nothing __attribute__((unused)))
                     g_set_shutdown( SLAPI_SHUTDOWN_DISKFULL );
                     return;
                 }
-                time(&now);
+                now = slapi_current_utc_time();
             }
 
             if(ok_now){
@@ -921,7 +903,6 @@ void slapd_daemon( daemon_ports_t *ports, ns_thrpool_t *tp )
 	PRFileDesc **fdesp = NULL;
 	PRIntn num_poll = 0;
 	PRIntervalTime pr_timeout = PR_MillisecondsToInterval(slapd_wakeup_timer);
-	PRThread *time_thread_p;
 	uint64_t threads;
 	int in_referral_mode = config_check_referral_mode();
 	int connection_table_size = get_configured_connection_table_size();
@@ -968,20 +949,6 @@ void slapd_daemon( daemon_ports_t *ports, ns_thrpool_t *tp )
 
 	init_op_threads();
 
-    /* Start the time thread */
-    time_thread_p = PR_CreateThread(PR_SYSTEM_THREAD,
-		(VFP) (void *) time_thread, NULL,
-        PR_PRIORITY_NORMAL, PR_GLOBAL_THREAD, 
-        PR_JOINABLE_THREAD, 
-        SLAPD_DEFAULT_THREAD_STACKSIZE);
-    if ( NULL == time_thread_p ) {
-		PRErrorCode errorCode = PR_GetError();
-		slapi_log_err(SLAPI_LOG_EMERG, "slapd_daemon", "Unable to create time thread - Shutting Down ("
-				SLAPI_COMPONENT_NAME_NSPR " error %d - %s)\n",
-				errorCode, slapd_pr_strerror(errorCode));
-		g_set_shutdown( SLAPI_SHUTDOWN_EXIT );
-	}
-
     /*
      *  If we are monitoring disk space, then create the mutex, the cvar,
      *  and the monitoring thread.
@@ -1135,7 +1102,6 @@ void slapd_daemon( daemon_ports_t *ports, ns_thrpool_t *tp )
             select_return = POLL_FN(the_connection_table->fd, num_poll, pr_timeout);
             switch (select_return) {
             case 0: /* Timeout */
-                /* GGOODREPL handle_timeout(); */
                 break;
             case -1: /* Error */
                 prerr = PR_GetError();
@@ -1305,7 +1271,6 @@ void slapd_daemon( daemon_ports_t *ports, ns_thrpool_t *tp )
 
 	/* tell the time thread to shutdown and then wait for it */
 	time_shutdown = 1;
-	PR_JoinThread( time_thread_p );
 
 	if ( g_get_shutdown() == SLAPI_SHUTDOWN_DISKFULL ){
 		/* This is a server-induced shutdown, we need to manually remove the pid file */
@@ -1563,38 +1528,6 @@ setup_pr_read_pds(Connection_Table *ct, PRFileDesc **n_tcps, PRFileDesc **s_tcps
 
 }
 
-#ifdef notdef /* GGOODREPL */
-static void
-handle_timeout( void )
-{
-	static time_t prevtime = 0;
-	static time_t housekeeping_fire_time = 0;
-	time_t curtime = current_time();
-
-	if (0 == prevtime) {
-		prevtime = time (&housekeeping_fire_time);
-	}
-
-	if ( difftime(curtime, prevtime) >= 
-		slapd_housekeeping_timer ) {
-		uint64_t num_active_threads;
-
-		snmp_collator_update();
-
-		prevtime = curtime;
-		num_active_threads = g_get_active_threadcnt();
-		if ( (num_active_threads == 0)  || 
-			(difftime(curtime, housekeeping_fire_time) >= 
-		slapd_housekeeping_timer*3) ) {
-		housekeeping_fire_time = curtime;
-			housekeeping_start(curtime);
-		}
-	}
-
-}
-#endif /* notdef */
-
-
 static int	idletimeout_reslimit_handle = -1;
 
 /*
@@ -1612,7 +1545,7 @@ static void
 handle_pr_read_ready(Connection_Table *ct, PRIntn num_poll __attribute__((unused)))
 {
 	Connection *c;
-	time_t curtime = current_time();
+	time_t curtime = slapi_current_utc_time();
 	int maxthreads = config_get_maxthreadsperconn();
 
 #if LDAP_ERROR_LOGGING
diff --git a/ldap/servers/slapd/eventq.c b/ldap/servers/slapd/eventq.c
index 8c6fca5..64c1d6b 100644
--- a/ldap/servers/slapd/eventq.c
+++ b/ldap/servers/slapd/eventq.c
@@ -202,16 +202,20 @@ slapi_eq_cancel(Slapi_Eq_Context ctx)
 static slapi_eq_context *
 eq_new(slapi_eq_fn_t fn, void *arg, time_t when, unsigned long interval)
 {
-	slapi_eq_context *retptr = (slapi_eq_context *)slapi_ch_calloc(1, sizeof(slapi_eq_context));
-	time_t now;
-
-	retptr->ec_fn = fn;
-	retptr->ec_arg = arg;
-	now = current_time();
-	retptr->ec_when = when < now ? now : when;
-	retptr->ec_interval = interval == 0UL ? 0UL : (interval + 999) / 1000;
-	retptr->ec_id = (Slapi_Eq_Context)retptr;
-	return retptr;
+    slapi_eq_context *retptr = (slapi_eq_context *)slapi_ch_calloc(1, sizeof(slapi_eq_context));
+
+    retptr->ec_fn = fn;
+    retptr->ec_arg = arg;
+    /*
+     * retptr->ec_when = when < now ? now : when;
+     * we used to amke this check, but it make no sense: when queued, if when
+     * has expired, we'll be executed anyway. save the cycles, and just set
+     * ec_when.
+     */
+    retptr->ec_when = when;
+    retptr->ec_interval = interval == 0UL ? 0UL : (interval + 999) / 1000;
+    retptr->ec_id = (Slapi_Eq_Context)retptr;
+    return retptr;
 }
 
 
@@ -277,18 +281,19 @@ static void
 eq_call_all(void)
 {
 	slapi_eq_context *p;
+    time_t curtime = slapi_current_utc_time();
 
-	while ((p = eq_dequeue(current_time())) != NULL) {
+	while ((p = eq_dequeue(curtime)) != NULL) {
 		/* Call the scheduled function */
 		p->ec_fn(p->ec_when, p->ec_arg);
 		slapi_log_err(SLAPI_LOG_HOUSE, NULL,
 				"Event id %p called at %ld (scheduled for %ld)\n",
-				p->ec_id, current_time(), p->ec_when);
+				p->ec_id, curtime, p->ec_when);
 		if (0UL != p->ec_interval) {
 			/* This is a repeating event. Requeue it. */
 			do {
 				p->ec_when += p->ec_interval;
-			} while (p->ec_when < current_time());
+			} while (p->ec_when < curtime);
 			eq_enqueue(p);
 		} else {
 			slapi_ch_free((void **)&p);
@@ -302,23 +307,22 @@ eq_call_all(void)
 /*
  * The main event queue loop.
  */
-#define WORK_AVAILABLE ((NULL != eq->eq_queue) && (eq->eq_queue->ec_when <= current_time()))
-
 static void
 eq_loop(void *arg __attribute__((unused)))
 {
 	while (eq_running) {
+        time_t curtime = slapi_current_utc_time();
 		PRIntervalTime timeout;
 		int until;
 		PR_Lock(eq->eq_lock);
-		while (!WORK_AVAILABLE) {
+		while (!(NULL != eq->eq_queue) && (eq->eq_queue->ec_when <= curtime)) {
 			if (!eq_running) {
 				PR_Unlock(eq->eq_lock);
 				goto bye;
 			}
 			/* Compute new timeout */
 			if (NULL != eq->eq_queue) {
-				until = eq->eq_queue->ec_when - current_time();
+				until = eq->eq_queue->ec_when - curtime;
 				timeout = PR_SecondsToInterval(until);
 			} else {
 				timeout = PR_INTERVAL_NO_TIMEOUT;
diff --git a/ldap/servers/slapd/generation.c b/ldap/servers/slapd/generation.c
index 76dffda..19c4422 100644
--- a/ldap/servers/slapd/generation.c
+++ b/ldap/servers/slapd/generation.c
@@ -25,11 +25,11 @@ new_dataversion(void)
 {
     struct tm t;
     char* dataversion;
-	time_t curtime = current_time();
+    time_t curtime = slapi_current_utc_time();
 
     gmtime_r (&curtime, &t);
     dataversion = slapi_ch_smprintf("0%.4li%.2i%.2i%.2i%.2i%.2i", 1900L + t.tm_year, 1 + t.tm_mon, t.tm_mday, t.tm_hour, t.tm_min, t.tm_sec);
-	return dataversion;
+    return dataversion;
 }
 
 /* ---------------- Database Data Version ---------------- */
diff --git a/ldap/servers/slapd/getfilelist.c b/ldap/servers/slapd/getfilelist.c
index 3b3f02f..81ca802 100644
--- a/ldap/servers/slapd/getfilelist.c
+++ b/ldap/servers/slapd/getfilelist.c
@@ -127,7 +127,7 @@ matches(const char *filename, const char *pattern)
 	re = slapi_re_comp( pattern, &error );
 	if (re) {
 		/* Matches the compiled pattern against the filename */
-		match = slapi_re_exec( re, filename, -1 /* no time limit */ );
+		match = slapi_re_exec_nt( re, filename);
 		slapi_re_free( re );
 	}
 
